package cn.iocoder.yudao.module.iot.service.kanban;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.mock.mockito.MockBean;

import javax.annotation.Resource;

import cn.iocoder.yudao.framework.test.core.ut.BaseDbUnitTest;

import cn.iocoder.yudao.module.iot.controller.admin.kanban.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.kanban.KanbanDO;
import cn.iocoder.yudao.module.iot.dal.mysql.kanban.KanbanMapper;
import cn.iocoder.yudao.framework.common.pojo.PageResult;


import org.springframework.context.annotation.Import;
import java.util.*;
import java.time.LocalDateTime;

import static cn.hutool.core.util.RandomUtil.*;
import static cn.iocoder.yudao.module.iot.enums.ErrorCodeConstants.*;
import static cn.iocoder.yudao.framework.test.core.util.AssertUtils.*;
import static cn.iocoder.yudao.framework.test.core.util.RandomUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.LocalDateTimeUtils.*;
import static cn.iocoder.yudao.framework.common.util.object.ObjectUtils.*;
import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * {@link KanbanServiceImpl} 的单元测试类
 *
 * @author 内蒙必硕
 */
@Import(KanbanServiceImpl.class)
public class KanbanServiceImplTest extends BaseDbUnitTest {

    @Resource
    private KanbanServiceImpl kanbanService;

    @Resource
    private KanbanMapper kanbanMapper;

    @Test
    public void testCreateKanban_success() {
        // 准备参数
        KanbanSaveReqVO createReqVO = randomPojo(KanbanSaveReqVO.class).setId(null);

        // 调用
        Long kanbanId = kanbanService.createKanban(createReqVO);
        // 断言
        assertNotNull(kanbanId);
        // 校验记录的属性是否正确
        KanbanDO kanban = kanbanMapper.selectById(kanbanId);
        assertPojoEquals(createReqVO, kanban, "id");
    }

    @Test
    public void testUpdateKanban_success() {
        // mock 数据
        KanbanDO dbKanban = randomPojo(KanbanDO.class);
        kanbanMapper.insert(dbKanban);// @Sql: 先插入出一条存在的数据
        // 准备参数
        KanbanSaveReqVO updateReqVO = randomPojo(KanbanSaveReqVO.class, o -> {
            o.setId(dbKanban.getId()); // 设置更新的 ID
        });

        // 调用
        kanbanService.updateKanban(updateReqVO);
        // 校验是否更新正确
        KanbanDO kanban = kanbanMapper.selectById(updateReqVO.getId()); // 获取最新的
        assertPojoEquals(updateReqVO, kanban);
    }

    @Test
    public void testUpdateKanban_notExists() {
        // 准备参数
        KanbanSaveReqVO updateReqVO = randomPojo(KanbanSaveReqVO.class);

        // 调用, 并断言异常
        assertServiceException(() -> kanbanService.updateKanban(updateReqVO), KANBAN_NOT_EXISTS);
    }

    @Test
    public void testDeleteKanban_success() {
        // mock 数据
        KanbanDO dbKanban = randomPojo(KanbanDO.class);
        kanbanMapper.insert(dbKanban);// @Sql: 先插入出一条存在的数据
        // 准备参数
        Long id = dbKanban.getId();

        // 调用
        kanbanService.deleteKanban(id);
       // 校验数据不存在了
       assertNull(kanbanMapper.selectById(id));
    }

    @Test
    public void testDeleteKanban_notExists() {
        // 准备参数
        Long id = randomLongId();

        // 调用, 并断言异常
        assertServiceException(() -> kanbanService.deleteKanban(id), KANBAN_NOT_EXISTS);
    }

    @Test
    @Disabled  // TODO 请修改 null 为需要的值，然后删除 @Disabled 注解
    public void testGetKanbanPage() {
       // mock 数据
       KanbanDO dbKanban = randomPojo(KanbanDO.class, o -> { // 等会查询到
           o.setCode(null);
           o.setTitle(null);
           o.setImg(null);
           o.setRemark(null);
           o.setIsEnable(null);
           o.setCreateTime(null);
       });
       kanbanMapper.insert(dbKanban);
       // 测试 code 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setCode(null)));
       // 测试 title 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setTitle(null)));
       // 测试 img 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setImg(null)));
       // 测试 remark 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setRemark(null)));
       // 测试 isEnable 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setIsEnable(null)));
       // 测试 createTime 不匹配
       kanbanMapper.insert(cloneIgnoreId(dbKanban, o -> o.setCreateTime(null)));
       // 准备参数
       KanbanPageReqVO reqVO = new KanbanPageReqVO();
       reqVO.setCode(null);
       reqVO.setTitle(null);
       reqVO.setImg(null);
       reqVO.setRemark(null);
       reqVO.setIsEnable(null);
       reqVO.setCreateTime(buildBetweenTime(2023, 2, 1, 2023, 2, 28));

       // 调用
       PageResult<KanbanDO> pageResult = kanbanService.getKanbanPage(reqVO);
       // 断言
       assertEquals(1, pageResult.getTotal());
       assertEquals(1, pageResult.getList().size());
       assertPojoEquals(dbKanban, pageResult.getList().get(0));
    }

}